accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from accounts.views import signup


urlpatterns = [
    path(
        "login/",
        auth_views.LoginView.as_view(),
        name="login",
    ),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

projects/urls.py
from django.urls import path


from projects.views import (
    ProjectListView,
    ProjectCreateView,
    ProjectDetailView,
)


urlpatterns = [
    path("", ProjectListView.as_view(), name="list_projects"),
    path("<int:pk>/", ProjectDetailView.as_view(), name="show_project"),
    path("create/", ProjectCreateView.as_view(), name="create_project"),
]

tasks/urls.py
from django.urls import path


from tasks.views import (
    TaskCreateView,
    TaskListView,
    TaskUpdateView,
)


urlpatterns = [
    path("create/", TaskCreateView.as_view(), name="create_task"),
    path("mine/", TaskListView.as_view(), name="show_my_tasks"),
    path("<int:pk>/complete/", TaskUpdateView.as_view(), name="complete_task"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic.base import RedirectView

urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("list_projects")),
        name="home",
    ),
    path("accounts/", include("accounts.urls")),
    path("tasks/", include("tasks.urls")),
]

accounts/models.py
# from django.db import models

# Create your models here.

projects/models.py
from django.db import models
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL


# Create your models here.
class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    members = models.ManyToManyField(
        USER_MODEL,
        related_name="projects",
    )

    def __str__(self):
        return self.name

tasks/models.py
from django.db import models
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL

# Create your models here.


class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField()
    due_date = models.DateTimeField()
    is_completed = models.BooleanField(default=False)
    project = models.ForeignKey(
        "projects.Project",
        related_name="tasks",
        on_delete=models.CASCADE,
    )
    assignee = models.ForeignKey(
        USER_MODEL,
        null=True,
        related_name="tasks",
        on_delete=models.SET_NULL,
    )

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import redirect, render
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login

# Create your views here.


def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            usernameAPP = request.POST.get("username")
            passwordAPP = request.POST.get("password1")
            # User is a model with a function create_user
            # setting our variables usernameAPP and passwordAPP
            # to the create_user parameters
            user = User.objects.create_user(
                username=usernameAPP, password=passwordAPP
            )
            user.save()
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm(request.POST)
    context = {"form": form}
    return render(request, "registration/signup.html", context)

projects/views.py
from django.shortcuts import redirect
from django.views.generic.list import ListView
from django.views.generic.edit import CreateView
from django.views.generic.detail import DetailView
from django.contrib.auth.mixins import LoginRequiredMixin


from projects.models import Project
from django.urls import reverse_lazy, reverse


class ProjectListView(LoginRequiredMixin, ListView):
    model = Project
    template_name = "projects/list.html"
    success_url = reverse_lazy("home")

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)

    def form_valid(self, form):
        plan = form.save(commit=False)
        plan.members = self.request.user
        plan.save()
        form.save_m2m()
        return redirect("home")


class ProjectDetailView(LoginRequiredMixin, DetailView):
    model = Project
    template_name = "projects/detail.html"
    fields = ["name", "description"]


class ProjectCreateView(LoginRequiredMixin, CreateView):
    model = Project
    template_name = "projects/new.html"
    fields = ["name", "description", "members"]

    def get_success_url(self):
        return reverse("show_project", kwargs={"pk": self.object.pk})

    def get_form_kwargs(self, *args, **kwargs):
        kwargs = super(ProjectCreateView, self).get_form_kwargs(
            *args, **kwargs
        )
        return kwargs

tasks/views.py
from django.views.generic.edit import CreateView, UpdateView
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy, reverse
from tasks.models import Task

# from django.shortcuts import render
# Create your views here.


class TaskCreateView(LoginRequiredMixin, CreateView):
    model = Task
    template_name = "tasks/new.html"
    fields = ["name", "start_date", "due_date", "project", "assignee"]
    success_url = reverse_lazy("list_projects")

    # a way to think about this: args=[self.object.(the field name of
    # what I'm trying to pull up).id])
    def get_success_url(self):
        return reverse("show_project", kwargs={"pk": self.object.project_id})

    # alternative solution is args bc we only need to pass 1 variable in there
    # return reverse("show_project", args=[self.object.project.id])


class TaskListView(LoginRequiredMixin, ListView):
    model = Task
    template_name = "tasks/list.html"
    fields = ["name", "assignee", "start_date", "end_date", "is_completed"]

    # this filters the results you get to the results of the assignee
    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)


class TaskUpdateView(UpdateView):
    model = Task
    fields = ["is_completed"]
    success_url = reverse_lazy("show_my_tasks")

projects/templates/base.html
{% load markdownify%}
{% load static %}

<!DOCTYPE html>
<html lang="en">
    <head>
        <title>My projects</title>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <link rel="stylesheet" href="{% static 'css/app.css' %}">
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    {% if user.is_authenticated %}
                        <li>
                            <a href="{% url 'show_my_tasks' %}">My tasks</a>
                        </li>
                        <li>
                            <a href="{% url 'list_projects' %}">My projects</a>
                        </li>
                        <li>
                            <a href="{% url 'logout' %}">Logout</a>
                        </li>
                    {% else %}
                        <li>
                            <a href="{% url 'login' %}">Login</a>
                        </li>
                        <li>
                            <a href="{% url 'signup' %}">Signup</a>
                        </li>
                    {% endif %}
                </ul>
            </nav>
        </header>
        {% block content %}
        {% endblock content %}
    </body>
</html>

projects/templates/projects/detail.html
{% extends 'base.html' %}
{% load markdownify %}

{% block content %}
    <main>
        <div>
            <h1>{{ project.name }}</h1>
            {{ project.description|markdownify }}
            <h2>Tasks</h2>
            <p>
                <a href="{% url 'create_task' %}">Create a new task</a>
            </p>
            {% comment %} project.tasks is a query in Django. When you apply
                all you are fetching the info from the query. The query is saying 
                from project get all of the tasks of this project. With all we are 
                actually fetching the data {% endcomment %}
            {% if project.tasks.all %}
                <table class="task-table">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Assignee</th>
                            <th>Start date</th>
                            <th>Due date</th>
                            <th>Is completed</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for task in project.tasks.all %}
                            <tr>
                                <td>{{ task.name }}</td>
                                <td>{{ task.assignee }}</td>
                                <td>{{ task.start_date }}</td>
                                <td>{{ task.due_date }}</td>
                                <td>{{ task.is_completed }}</td>                                </tr>
                        {% empty %}
                            <p>This project has no tasks</p>
                        {% endfor %}
                    </tbody>
                </table>
            {% else %}
                <p>This project has no tasks</p>
            {% endif %}
        </div>
    </main>
{% endblock content %}

projects/templates/projects/list.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>My Projects</h1>
            <p>
                <a href="{% url 'create_project' %}">Create a new project</a>
            </p>
            {% if user.is_authenticated %}
                {% if project_list %}
                    <table>
                        <thead>
                            <tr>
                                <th>Name</th>
                                <th>Number of tasks</th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for project in project_list %}
                                <tr>
                                    <td><a href="{% url 'show_project' project.id %}">{{ project.name }}</a></td>
                                    <td>{{ project.tasks.all|length }}</td>
                                </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                {% else %}
                    <p>You are not assigned to any projects</p>
                {% endif %}
            {% endif %}
        </div>
    </main>
{% endblock content %}

projects/templates/projects/new.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Create a new project</h1>
            <form method="post">
                {% csrf_token %}
                {{ form.as_p }}
                <button type="submit">Create</button>
            </form>
        </div>
    </main>
{% endblock content %}

tasks/templates/tasks/list.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>My Tasks</h1>
            {% if task_list %}
                {% comment %} {% if task.tasks %} {% endcomment %}
                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Start date</th>
                            <th>End date</th>
                            <th>Is completed</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for task in task_list %}
                            <tr>
                                <td>{{ task.name }}</td>
                                <td>{{ task.start_date }}</td>
                                <td>{{ task.due_date }}</td>
                                <td>
                                    {% if task.is_completed is False %}
                                        <form method="post" action="{% url 'complete_task' task.id %}">
                                            {% csrf_token %}
                                            <input type="hidden" name="is_completed" value="True">
                                            <button>Complete</button>
                                        </form>
                                    {% else %}
                                        Done
                                    {% endif %}
                                </td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            {% else %}
                <p>You have no tasks</p>
            {% endif %}
        </div>
    </main>
{% endblock content %}

tasks/templates/tasks/new.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Create a new task</h1>
            <form method="post">
                {% csrf_token %}
                {{ form.as_p }}
                <button type="submit">Create</button>
            </form>
        </div>
    </main>
{% endblock content %}